<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/12/2008 *
 * ===============                              Last change: 12/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : pool-user.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Sends queued user mails from the pool            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet freigegebene Mitglieder-Mails aus Pool    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Don't run on daily reset
if (isResetModeEnabled()) {
	// Skip here
	return false;
} elseif (!isExtensionActive('user')) {
	// Abort here if extension user is not active
	return false;
}

// Need this here
// Check for freed mail orders to send out
if (isExtensionActive('html_mail')) {
	//                                0     1        2      3       4          5            6      7        8          9       10
	$result_main = SQL_QUERY("SELECT id, sender, subject, text, receivers, payment_id, timestamp, url, target_send, cat_id, html_msg FROM `{?_MYSQL_PREFIX?}_pool` WHERE `data_type`='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
} else {
	//                                0     1        2      3       4          5            6      7        8          9    10
	$result_main = SQL_QUERY("SELECT id, sender, subject, text, receivers, payment_id, timestamp, url, target_send, cat_id, id FROM `{?_MYSQL_PREFIX?}_pool` WHERE `data_type`='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
}

// Reset variables
$cnt2 = 0; $lastSentId = 0; $cnt_back = array(0); $pointsBack = array(0);
if (SQL_NUMROWS($result_main) > 0) {
	// Parse all mails
	while ($DATA = SQL_FETCHARRAY($result_main, 0, false)) {
		// Set mail order as 'active'. That means it will be sent out
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='ACTIVE' WHERE `id`=%s AND `data_type`='NEW' LIMIT 1",
			array($DATA['id']), __FILE__, __LINE__);

		// Check fetched data for HTML
		$HTML = 'N';
		if (isset($DATA['html_msg'])) $HTML = $DATA['html_msg'];

		// Entry updated?
		if (SQL_AFFECTEDROWS() == 1) {
			// "Explode" all receivers into an array
			if (ereg(';', $DATA['receivers'])) {
				// There's more than one receiver in the list...
				$RECEIVERS = explode(';', $DATA['receivers']);
			} elseif (!empty($DATA['receivers'])) {
				// Only one user left
				$RECEIVERS = array($DATA['receivers']);
			} else {
				// No users left
				$RECEIVERS = array(0);
			}
			$dummy = $RECEIVERS;

			// Now, if we are good little boys and girls Santa left us some user-ids.
			// We can now send mails to them...
			foreach ($RECEIVERS as $key => $userid) {
				// Lookup user id
				$result_user = SQL_QUERY_ESC("SELECT gender, surname, family, email FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
					array(bigintval($userid)), __FILE__, __LINE__);

				// Is his data available?
				//* DEBUG: */ outputHtml("*L:".__LINE__.'/'.SQL_NUMROWS($result_user)."*<br />");
				if (SQL_NUMROWS($result_user) == 1) {
					// The final receiver does exists so we can continue...
					list($gender, $surname, $family, $email) = SQL_FETCHROW($result_user);

					// Free memory
					SQL_FREERESULT($result_user);

					// Do we have a stats entry?
					$result_stats = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s AND `userid`=%s AND timestamp_ordered='%s' LIMIT 1",
						array($DATA['id'], $DATA['sender'], $DATA['timestamp']), __FILE__, __LINE__);

					// If there's no stats entry add it!
					//* DEBUG: */ outputHtml("!L:".__LINE__.'/'.SQL_NUMROWS($result_stats)."!<br />");
					if (SQL_NUMROWS($result_stats) == 0) {
						// No entry was found, so we add him!
						SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_stats` (`pool_id` , `userid`, `cat_id`, `payment_id`, `subject`, `url` , `max_rec` , `timestamp_ordered`, `timestamp_sstart`) VALUES ('%s','%s','%s','%s','%s','%s','%s','%s' , UNIX_TIMESTAMP())",
							array(bigintval($DATA['id']), bigintval($DATA['sender']), bigintval($DATA['cat_id']), bigintval($DATA['payment_id']), $DATA['subject'], $DATA['url'], $DATA['target_send'], bigintval($DATA['timestamp'])), __FILE__, __LINE__);

						// Receive it's id for the links table
						$result_stats = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s AND `userid`=%s AND timestamp_ordered='%s' LIMIT 1",
							array(bigintval($DATA['id']), bigintval($DATA['sender']), bigintval($DATA['timestamp'])), __FILE__, __LINE__);
					} // END - if

					//* DEBUG: */ outputHtml("!L:".__LINE__.'/'.SQL_NUMROWS($result_stats)."!<br />");
					if (SQL_NUMROWS($result_stats) == 1) {
						// We got one!
						list($stats_id) = SQL_FETCHROW($result_stats);

						// Mark this user as "spammed" ;-) And place a line for him...
						//* DEBUG: */ outputHtml("?L:".__LINE__.'/'.$dummy.'/'.$key.'/'.$userid.'('.['sender'].")/".$DATA['id'].'/'.$stats_id."?<br />");
						switch (removeReceiver($dummy, $key, bigintval($userid), bigintval($DATA['id']), bigintval($stats_id))) {
							case 'done':
								// Prepare the mail
								$DATA['stats_id'] = bigintval($stats_id);
								$DATA['surname']  = $surname;
								$DATA['family']   = $family;
								$DATA['gender']   = translateGender($gender);

								// Replace text variables
								foreach ($GLOBALS['replacer'] as $key => $value) {
									if (isset($DATA[$key])) $DATA['text'] = str_replace($value, $DATA[$key], $DATA['text']);
								} // END - if

								// Prepare content
								$content = array(
									'id'            => $DATA['stats_id'],
									'url'           => $DATA['url'],
									'sender_userid' => $DATA['sender'],
									'category'      => getCategory($DATA['cat_id']),
									'time'          => createFancyTime(getPaymentPoints($DATA['payment_id'], 'time')),
									'points'        => translateComma(getPaymentPoints($DATA['payment_id'], 'payment')),
									'text'          => $DATA['text']
								);

								// Load message template
								$mailText = loadEmailTemplate('normal-mail', $content, bigintval($userid));

								// Send mail away
								sendEmail($email, $DATA['subject'], $mailText, $HTML);

								// Count sent mails...
								SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET emails_sent=emails_sent+1 WHERE `userid`=%s LIMIT 1",
									array(bigintval($DATA['sender'])), __FILE__, __LINE__);

								if (getExtensionVersion('user') >= '0.1.4') {
									// Update mails received for receiver
									SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET emails_received=emails_received+1 WHERE `userid`=%s LIMIT 1",
										array(bigintval($userid)), __FILE__, __LINE__);
								} // END - if

								// Update mediadata if version is 0.0.4 or higher
								if (getExtensionVersion('mediadata') >= '0.0.4') {
									// Update entry (or add missing)
									//* DEBUG: */ outputHtml("*MEDIA/L:".__LINE__."*<br />");
									updateMediadataEntry(array('total_send', 'normal_send'), 'add', 1);
								} // END - if

								// And count up the mail
								$GLOBALS['pool_cnt']++;
								//* DEBUG: */ outputHtml("*EXIT/L:".__LINE__.'/'.$GLOBALS['pool_cnt']."*<br />");
								break;

							case 'already':
								// Entry already found, but we still count one up!
								$GLOBALS['pool_cnt']++;
								//* DEBUG: */ outputHtml("*EXIT/L:".__LINE__.'/'.$GLOBALS['pool_cnt']."<br />");
								break;
						}
					}

					// Do we have reached the maximum to send mails? || (getConfig('max_send') >= $GLOBALS['pool_cnt'])
					//* DEBUG: */ outputHtml("*L:".__LINE__.'/'.$GLOBALS['pool_cnt'].">=".$DATA['target_send'].'/'.getConfig('max_send').">=".$GLOBALS['pool_cnt'].'/'.$lastSentId."!=".$DATA['id']."*<br />");
					if ((($GLOBALS['pool_cnt'] >= $DATA['target_send'])) && ($lastSentId != $DATA['id'])) {
						// Prepare content
						$content = array(
							'sender_userid' => $DATA['sender'],
							'category'      => getCategory($DATA['cat_id']),
							'text'          => $DATA['text'],
							'url'           => $DATA['url'],
							'expiration'    => createFancyTime(getPaymentPoints($DATA['payment_id'], "time"))
						);

						// Yes we do, so we notify admin and sender about fully sent mail!
						sendAdminNotification(getMessage('ADMIN_SUBJ_SEND_DONE'), 'done-admin', $content, $userid);

						// Get sender's data
						$result_sender = SQL_QUERY_ESC("SELECT `surname`, `family`, `email` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
							array(bigintval($DATA['sender'])), __FILE__, __LINE__);

						// Is the sender found?
						if (SQL_NUMROWS($result_sender) == 1) {
							// Load data and prepare mail
							list($surname, $family, $email) = SQL_FETCHROW($result_sender);

							// Load email template
							$mailText = loadEmailTemplate('done-member', $content, $DATA['sender']);

							// Send it also waway
							sendEmail($email, getMessage('MEMBER_SUBJ_SEND_DONE'), $mailText);
						} // END - if

						// Free result
						SQL_FREERESULT($result_sender);

						// Set status to SEND because we completely send it away
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='SEND', `target_send`=0, `receivers`='' WHERE `id`=%s LIMIT 1",
							array(bigintval($DATA['id'])), __FILE__, __LINE__);

						// Update send-completed-time
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_stats` SET `timestamp_send`=UNIX_TIMESTAMP() WHERE `pool_id`=%s LIMIT 1",
							array(bigintval($DATA['id'])), __FILE__, __LINE__);

						$lastSentId = $DATA['id']; $GLOBALS['pool_cnt'] = 0;
						$cnt2 += $GLOBALS['pool_cnt'];

						// Update mediadata if version is 0.0.4 or higher
						if (getExtensionVersion('mediadata') >= '0.0.4') {
							// Update entry (or add missing)
							//* DEBUG: */ outputHtml("*MEDIA/L:".__LINE__."*<br />");
							updateMediadataEntry(array('total_orders', 'normal_orders'), 'add', 1);
						} // END - if

						//* DEBUG: */ outputHtml("*EXIT/L:".__LINE__.'/'.$P."<br />");
						break;
					}
					// Do we have send maximum mails?
					elseif (($GLOBALS['pool_cnt'] >= getConfig('max_send')) || ($cnt2 >= getConfig('max_send'))) {
						// There are some mails left to send for next round, so we reset the status back to NEW (=still not fully delivered)
						$add = '';
						if ($GLOBALS['pool_cnt'] <= $DATA['target_send']) $add = ", target_send=target_send-".$GLOBALS['pool_cnt'];
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='NEW', receivers='%s'".$add." WHERE `id`=%s LIMIT 1",
							array(implode(';', $dummy), bigintval($DATA['id'])), __FILE__, __LINE__);

						//* DEBUG: */ outputHtml("*EXIT/L:".__LINE__."*<br />");
						break;
					}

					// Free result
					SQL_FREERESULT($result_stats);
				} else {
					// User does not exists so we have add the sender's points back to sender's account
					if (($RECEIVERS['id'] == 0) || (empty($RECEIVERS['id']))) {
						// List was empty
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='SEND' WHERE `id`=%s LIMIT 1",
							array(bigintval($DATA['id'])), __FILE__, __LINE__);
					} else {
						// Is the userid set?
						if ($userid > 0) {
							// User does not exists, pay points back
							$points = getPaymentPoints($DATA['payment_id']);
							addPointsDirectly('pool_payback', $DATA['sender'], $points);

							// Add points together and remove user
							$pointsBack[$DATA['sender']] += $points;
						} // END - if

						// Count up
						$cnt_back[$DATA['sender']]++;
					}

					// Remove entry from list
					unset($dummy[$key]);

					// Update receivers
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `receivers`='%s' WHERE `id`=%s LIMIT 1",
						array(implode(';', $dummy), bigintval($DATA['id'])), __FILE__, __LINE__);
				}
			}
		}
	}

	// Do we have points to "pay back"?
	if ((count($pointsBack) > 0) && (!empty($pointsBack[0]))) {
		// Walk through all points
		foreach ($pointsBack as $userid => $PB) {
			// Add points only when we have points left to add and a valid user id
			if (($PB > 0) && ($userid > 0)) {
				// Prepare content
				$content = array(
					'points' => translateComma($PB)
				);

				// We have to pay back some points to the sender (we add them directly :-P)
				$result = SQL_QUERY_ESC("SELECT `email` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s AND `status`='CONFIRMED' LIMIT 1",
					array(bigintval($userid)), __FILE__, __LINE__);

				// User found?
				if (SQL_NUMROWS($result) == 1) {
					// Get email
					list($email) = SQL_FETCHROW($result);

					// User account does exists, so we can safely pay back!
					$mailText = loadEmailTemplate('back-member', $content, bigintval($userid));

					// Send mail out to member
					sendEmail($email, getMessage('MEMBER_BACK_JACKPOT') . ' (' . $userid . ')', $mailText);
				} elseif (isExtensionActive('jackpot')) {
					// Add to jackpot
					addPointsToJackpot($PB);

					// Send mail out to admin
					sendAdminNotification(getMessage('ADMIN_BACK_JACKPOT') . ' (' . $userid . ')', 'back-admin', $content, 'admin');
				}

				// Free result
				SQL_FREERESULT($result);
			} // END - if
		} // END - foreach
	} // END - if
}

// Free memory
SQL_FREERESULT($result_main);

// Remove variable
unset($mailText);

//
?>
